# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: terrain.tcl,v 1.8 2003/02/09 16:31:26 matthieu Exp $

package require Terrain

source $env(GDHE)/examples/lutTerrain.tcl

# Definit les couleurs du terrain
set mntColor(0) { 120 60 0 }
set mntColor(1) { 60 120 0 }

# Une fonction pour placer un mnt dans l'affichage
proc placeMnt {mnt cropDpy lightDpy} {
    
    object $mnt {
	cullFace false
	terrain $mnt $cropDpy $lightDpy
    }
}

# TODO : passer 'terrainStruct' en global ?
proc updateMnt {mnt fileName} {
    updateTerrain $mnt $fileName
    objectDelete $mnt
    puts "Updating the DEM display";
    redrawAllWindows
}

proc initMntDisplay {fileName color cropDpy lightDpy} {
    
    if {$color != 0} {
	mntLutBW;
    } else {
	mntLutGreen
    }
    set ::mntColor(0) { 120 60 0 };	# So that the ground is always brown

    readTerrain terrainStruct $fileName
    set ::robots(pipo) " placeMnt terrainStruct $cropDpy $lightDpy "
    set ::pos(pipo) { 0 0 0 }
    puts "Initializing the DEM display";
    redrawAllWindows;
}

# Exemple de lecture de terrain et d'affichage : 
# readTerrain dem0 /home/simon/lama/gdheWd/terrains/dem.End
# readTerrainGeroms eden ed20223.fz
# set robots(mnt) { placeMnt dem0 $crop $light}
# (Tester des valeurs pour 'crop' et 'light' de 0 et de 1 : cela conditionne
# la manire dont est affiche le modle de terrain)
# set pos(mnt) { 0 0 0 }

# Exemple de lecture "incrmentale" d'un modle de terrain
# initMntDisplay /home/simon/lama/gdheWd/terrains/dem.Init $color $crop $light
# Les trois paramtres 'color', 'crop' et 'light' vont dterminer le type
# d'affichage qu'on fait ('color = 1' indique si on affiche les niveaux de
# gris contenus dans le modle de terrain. a n'est pas vraiment trs joli,
# mais bon) 
# puis :
# updateMnt terrainStruct /home/simon/lama/gdheWd/terrains/dem.0
# updateMnt terrainStruct /home/simon/lama/gdheWd/terrains/dem.5
# updateMnt terrainStruct /home/simon/lama/gdheWd/terrains/dem.10 ... dem.50


# Pour detruire un terrain il faut appeler dans cet ordre: 
# unset robots(mnt)
# deleteTerrain dem0
# objectDelete dem0

readTerrain dem0 $env(GDHE)/images/t3
set robots(mnt) { placeMnt dem0 0 1 }
set pos(mnt) { -10 -10 0 }

# Define obervator's position
.gdhe.ogl.pos.dist set 20
.gdhe.ogl.pos.elev set 25
.gdhe.ogl.pos.x set 5
.gdhe.ogl.pos.y set 5 

